#ifndef _OFTMPSTREAM_HXX
#define _OFTMPSTREAM_HXX

#include <iostream>
#include <fstream>
#include <string>

class fdoutbuf : public std::streambuf {
  protected:
    int fd;    // file descriptor
  public:
    fdoutbuf () {
    }
    void set_fd(int _fd);
  protected:
    virtual int_type overflow (int_type c);
    virtual std::streamsize xsputn (const char* s, std::streamsize num);
};

/// This class is deprecated, use I2n::tmpofcopystream instead.
class oftmpstream : public std::ostream {
public:
    oftmpstream ();
    oftmpstream (const std::string &name);
    ~oftmpstream ();
    void open (const std::string &name);
    void close();
    std::string get_filename();
    std::string get_tmp_filename();
    void set_file_mode(int mode);
private:
    int fd;
    fdoutbuf buf;
    bool is_open;
    int file_mode;

    std::string tmpname;
    std::string realname;
};


#endif
